## org.eclipse.jetty.server.ssl
Interface SslConnector

All Superinterfaces:
  Connector, LifeCycle

All Known Implementing Classes:
  SslSelectChannelConnector, SslSocketConnector

    public interface SslConnector

extends Connector

The interface for SSL connectors and their configuration methods.

Nested Class Summary

Nested classes/interfaces inherited from interface org.eclipse.jetty.util.component.LifeCycle
`LifeCycle.Listener`

Field Summary
`static String` `DEFAULT_KEYSTORE` Default value for the keystore location path.
`static String` `DEFAULT_KEYSTORE_ALGORITHM`
`static String` `DEFAULT_TRUSTSTORE_ALGORITHM`
`static String` `KEYPASSWORD_PROPERTY` String name of key password property.
`static String` `PASSWORD_PROPERTY` String name of keystore password property.

Method Summary
`String[]` `getExcludeCipherSuites()`
`String[]` `getIncludeCipherSuites()`
`String` `getKeystore()`
`String` `getKeystoreType()`
`boolean` `getNeedClientAuth()`
`String` `getProtocol()`
`String` `getProvider()`
`String` `getSecureRandomAlgorithm()`
`SSLContext` `getSslContext()`
`String` `getSslKeyManagerFactoryAlgorithm()`
`String` `getSslTrustManagerFactoryAlgorithm()`
`String` `getTruststore()`
`String` `getTruststoreType()`
`boolean` `getWantClientAuth()`
`boolean` `isAllowRenegotiate()`
`void` `setAllowRenegotiate(boolean allowRenegotiate)` Set if SSL re-negotiation is allowed.
`void` `setExcludeCipherSuites(String[] cipherSuites)`
`void` `setIncludeCipherSuites(String[] cipherSuites)`
`void` `setKeyPassword(String password)`
`void` `setKeystore(String keystore)`
`void` `setKeystoreType(String keystoreType)`
`void` `setNeedClientAuth(boolean needClientAuth)`
`void` `setPassword(String password)`
`void` `setProtocol(String protocol)`
`void` `setProvider(String provider)`
`void` `setSecureRandomAlgorithm(String algorithm)`
`void` `setSslContext(SSLContext sslContext)`
`void` `setSslKeyManagerFactoryAlgorithm(String algorithm)`
`void` `setSslTrustManagerFactoryAlgorithm(String algorithm)`
`void` `setTrustPassword(String password)`
`void` `setTruststore(String truststore)`
`void` `setTruststoreType(String truststoreType)`
`void` `setWantClientAuth(boolean wantClientAuth)`

Methods inherited from interface org.eclipse.jetty.server.Connector

`close, customize, getConfidentialPort, getConfidentialScheme, getConnection, getConnections, getConnectionsDurationMax, getConnectionsDurationMean, getConnectionsDurationStdDev, getConnectionsDurationTotal, getConnectionsOpen, getConnectionsOpenMax, getConnectionsRequestsMax, getConnectionsRequestsMean, getConnectionsRequestsStdDev, getHost, getIntegralPort, getIntegralScheme, getLocalPort, getLowResourceMaxIdleTime, getMaxIdleTime, getName, getPort, getRequestBuffers, getRequestBufferSize, getRequestHeaderSize, getRequests, getResolveNames, getResponseBuffers, getResponseBufferSize, getResponseHeaderSize, getServer, getStatsOn, getStatsOnMs, isConfidential, isIntegral, isLowResources, open, persist, setHost, setLowResourceMaxIdleTime, setMaxIdleTime, setPort, setRequestBufferSize, setRequestHeaderSize, setResponseBufferSize, setResponseHeaderSize, setServer, setStatsOn, statsReset`

Methods inherited from interface org.eclipse.jetty.util.component.LifeCycle
`addLifeCycleListener, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

Field Detail

### DEFAULT_KEYSTORE_ALGORITHM

    static final String DEFAULT_KEYSTORE_ALGORITHM

### DEFAULT_TRUSTSTORE_ALGORITHM

    static final String DEFAULT_TRUSTSTORE_ALGORITHM

### DEFAULT_KEYSTORE

    static final String DEFAULT_KEYSTORE

  Default value for the keystore location path.

### KEYPASSWORD_PROPERTY

    static final String KEYPASSWORD_PROPERTY

  String name of key password property.

  See Also:
    Constant Field Values

### PASSWORD_PROPERTY

    static final String PASSWORD_PROPERTY

  String name of keystore password property.

  See Also:
    Constant Field Values

Method Detail

### getExcludeCipherSuites

    String[] getExcludeCipherSuites()

  Returns:
    The array of Ciphersuite names to exclude from `SSLEngine.setEnabledCipherSuites(String[])`

### setExcludeCipherSuites

    void setExcludeCipherSuites(String[] cipherSuites)

  Parameters:
    `cipherSuites` - The array of Ciphersuite names to exclude from `SSLEngine.setEnabledCipherSuites(String[])`

### getIncludeCipherSuites

    String[] getIncludeCipherSuites()

  Returns:
    The array of Ciphersuite names to include in `SSLEngine.setEnabledCipherSuites(String[])`

### setIncludeCipherSuites

    void setIncludeCipherSuites(String[] cipherSuites)

  Parameters:
    `cipherSuites` - The array of Ciphersuite names to include in `SSLEngine.setEnabledCipherSuites(String[])`

### setPassword

    void setPassword(String password)

  Parameters:
    `password` - The password for the key store

### setTrustPassword

    void setTrustPassword(String password)

  Parameters:
    `password` - The password for the trust store

### setKeyPassword

    void setKeyPassword(String password)

  Parameters:
    `password` - The password (if any) for the specific key within the key store

### getProtocol

    String getProtocol()

  Returns:
    The SSL protocol (default "TLS") passed to `SSLContext.getInstance(String, String)`

### setProtocol

    void setProtocol(String protocol)

  Parameters:
    `protocol` - The SSL protocol (default "TLS") passed to `SSLContext.getInstance(String, String)`

### setKeystore

    void setKeystore(String keystore)

  Parameters:
    `keystore` - The file or URL of the SSL Key store.

### getKeystore

    String getKeystore()

  Returns:
    The file or URL of the SSL Key store.

### getKeystoreType

    String getKeystoreType()

  Returns:
    The type of the key store (default "JKS")

### getNeedClientAuth

    boolean getNeedClientAuth()

  Returns:
    True if SSL needs client authentication.
  See Also:
    `SSLEngine.getNeedClientAuth()`

### getWantClientAuth

    boolean getWantClientAuth()

  Returns:
    True if SSL wants client authentication.
  See Also:
    `SSLEngine.getWantClientAuth()`

### setNeedClientAuth

    void setNeedClientAuth(boolean needClientAuth)

  Parameters:
    `needClientAuth` - True if SSL needs client authentication.
  See Also:
    `SSLEngine.getNeedClientAuth()`

### setWantClientAuth

    void setWantClientAuth(boolean wantClientAuth)

  Parameters:
    `wantClientAuth` - True if SSL wants client authentication.
  See Also:
    `SSLEngine.getWantClientAuth()`

### setKeystoreType

    void setKeystoreType(String keystoreType)

  Parameters:
    `keystoreType` - The type of the key store (default "JKS")

### getProvider

    String getProvider()

  Returns:
    The SSL provider name, which if set is passed to `SSLContext.getInstance(String, String)`

### getSecureRandomAlgorithm

    String getSecureRandomAlgorithm()

  Returns:
    The algorithm name, which if set is passed to `SecureRandom.getInstance(String)` to obtain the `SecureRandom` instance passed to `SSLContext.init(javax.net.ssl.KeyManager[], javax.net.ssl.TrustManager[], SecureRandom)`

### getSslKeyManagerFactoryAlgorithm

    String getSslKeyManagerFactoryAlgorithm()

  Returns:
    The algorithm name (default "SunX509") used by the `KeyManagerFactory`

### getSslTrustManagerFactoryAlgorithm

    String getSslTrustManagerFactoryAlgorithm()

  Returns:
    The algorithm name (default "SunX509") used by the `TrustManagerFactory`

### getTruststore

    String getTruststore()

  Returns:
    The file name or URL of the trust store location

### getTruststoreType

    String getTruststoreType()

  Returns:
    The type of the trust store (default "JKS")

### setProvider

    void setProvider(String provider)

  Parameters:
    `provider` - The SSL provider name, which if set is passed to `SSLContext.getInstance(String, String)`

### setSecureRandomAlgorithm

    void setSecureRandomAlgorithm(String algorithm)

  Parameters:
    `algorithm` - The algorithm name, which if set is passed to `SecureRandom.getInstance(String)` to obtain the `SecureRandom` instance passed to `SSLContext.init(javax.net.ssl.KeyManager[], javax.net.ssl.TrustManager[], SecureRandom)`

### setSslKeyManagerFactoryAlgorithm

    void setSslKeyManagerFactoryAlgorithm(String algorithm)

  Parameters:
    `algorithm` - The algorithm name (default "SunX509") used by the `KeyManagerFactory`

### setSslTrustManagerFactoryAlgorithm

    void setSslTrustManagerFactoryAlgorithm(String algorithm)

  Parameters:
    `algorithm` - The algorithm name (default "SunX509") used by the `TrustManagerFactory`

### setTruststore

    void setTruststore(String truststore)

  Parameters:
    `truststore` - The file name or URL of the trust store location

### setTruststoreType

    void setTruststoreType(String truststoreType)

  Parameters:
    `truststoreType` - The type of the trust store (default "JKS")

### setSslContext

    void setSslContext(SSLContext sslContext)

  Parameters:
    `sslContext` - Set a preconfigured SSLContext

### getSslContext

    SSLContext getSslContext()

  Returns:
    The SSLContext

### isAllowRenegotiate

    boolean isAllowRenegotiate()

  Returns:
    True if SSL re-negotiation is allowed (default false)

### setAllowRenegotiate

    void setAllowRenegotiate(boolean allowRenegotiate)

  Set if SSL re-negotiation is allowed. CVE-2009-3555 discovered a vulnerability in SSL/TLS with re-negotiation. If your JVM does not have CVE-2009-3555 fixed, then re-negotiation should not be allowed.

  Parameters:
    `allowRenegotiate` - true if re-negotiation is allowed (default false)

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.